///////////////////////////////////////////
//																       //
//  Implementaion of the Container Class //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#include "Container.h"
#include "Number.h"
#include <iostream.h>


//--------------------------------------------------------------------------------
//	ctor
//-------------------------------------------------------------------------------- 
Container::Container()
 :m_count(0), m_head(0) {}

//--------------------------------------------------------------------------------
//	cctor
//-------------------------------------------------------------------------------- 
Container::Container(const Container &other)
{
	m_head = other.m_head;
	m_count = other.m_count;
}



//--------------------------------------------------------------------------------
//	Add object to the list (from the front)
//-------------------------------------------------------------------------------- 
void Container::Add(Number *numPtr)
{
	numPtr->m_nextPtr = m_head; // for first object, its nextPtr will points to NULL
											    		// meaning that it is the last object
	m_head = numPtr;
	m_count += 1;	
}


//--------------------------------------------------------------------------------
//	Search for an object and returns a base class object pointer
//-------------------------------------------------------------------------------- 
Number *Container::Search(Number *numPtr) const
{
	Number *tempPtr=m_head;
	for (int i=0; i<m_count; i++)
	{	
		if (*tempPtr == *numPtr) // invoke Number ==op
			return tempPtr;
		else
			tempPtr = tempPtr->m_nextPtr;
	}
	return 0;

	// I can also compare their string member directly 
	// i.e. if ((tempPtr->m_string == numPtr->m_string)
	// this will invoke the class VString ==op operator
}


//--------------------------------------------------------------------------------
//	Search for a String
//-------------------------------------------------------------------------------- 
Number *Container::Search(char *string) const
{
	Number *tempPtr=m_head;
	for (int i=0; i<m_count; i++)
	{	
		if (tempPtr->m_string == string)
			return tempPtr;
		else
			tempPtr = tempPtr->m_nextPtr;
	}
	
	return 0;	
}


//--------------------------------------------------------------------------------
//	Remove an object from the collecton
//-------------------------------------------------------------------------------- 
void Container::Remove(Number *numPtr)
{
	Number *tempPtr=m_head;

  if (m_head == numPtr)
	{
		m_head = numPtr->m_nextPtr;
		m_count -= 1;
		return;
	}
	
	for (int i=m_head->count_current; i>0; i--)
	{	
		if (tempPtr->m_nextPtr == numPtr) 
		{
			tempPtr->m_nextPtr=numPtr->m_nextPtr;
			m_count -= 1;
			return;
		}
		else
			{tempPtr = tempPtr->m_nextPtr;}
	}
}


//--------------------------------------------------------------------------------
//  Remove all objects from the collection (linklist) 
//  without destroying the objects themselves
//-------------------------------------------------------------------------------- 
void Container::Reset(void)
{
	m_count = 0;
}


//--------------------------------------------------------------------------------
//	Display the link list
//-------------------------------------------------------------------------------- 
void Container::Display(BOOL needCRLF) const
{
	Number *temp=m_head;

	if (m_count == 0)
	{	
		cout << "The current linklist is empty\n";
		if (needCRLF) 
			cout << '\n';
		return;
	}

	cout << "The current linklist:\n";
	for (int i=0; i < m_count - 1; i++)
	{
		temp->m_string.Display();
		temp=temp->m_nextPtr;
		cout<< "->";
	}
	temp->m_string.Display();
	if (m_count == 1) cout << "->0";
	if (needCRLF) cout << '\n';
}

