///////////////////////////////////////////
//																       //
//  Test driver for Homework # 6         //
//																       //
//					Chungho Chau					       //
//																			 //
//					March 17, 1998							 //
//																       //
///////////////////////////////////////////

#include <iostream.h>
#include "Number.h"
#include "Container.h"
#include "DoubleNumber.h"
#include "IntNumber.h"


// A yuky global function
void Display_Object_Counters(void)
{
	cout<< "Total # of objects instantiated is " << Number::count_total << endl;
	cout<< "Number of alive objects is         " << Number::count_current << endl;
}


void main()
{ 
	// create a container object
	Container collection;

	// add some integer objects
	IntNumber num1 (44, "I'm integer #1");
	IntNumber num2 (55, "I'm integer #2");
	collection.Add (&num1);
	collection.Add (&num2);

	// add some double objects
	DoubleNumber num3 (67.89, "I'm double #1");
	DoubleNumber num4 (1.23,  "I'm double #2");
	collection.Add (&num3);
	collection.Add (&num4);

	Display_Object_Counters();
	cout << endl;

	// display the list
	collection.Display(TRUE);
	cout << endl;
	
	// search for an object 
	cout << "The object found in the list is: ";
  collection.Search(&num3)->Display(TRUE); // returns a base class pointer
	cout << endl;
  
	// search for an object based its string description
	cout << "Search in the list using member string: ";
	collection.Search("I'm double #1")->Display(TRUE);
	cout << endl;
	
	// remove an object  
	cout << "After removing object 'I'm integer #1'\n";
	collection.Remove(&num1);
	collection.Display(TRUE);
	cout << endl;

	cout << "After removing object 'I'm Double #2'\n";
	collection.Remove(&num4);
	collection.Display(TRUE);
	cout << endl;
	
	// test Reset function
  cout << "After reseting the linklist\n";
	collection.Reset();
	collection.Display(TRUE);
	
	cout << "Now add back an object 'I'm double #3'\n";
	DoubleNumber num5 (1.01,  "I'm double #3");
	collection.Add (&num5);
	collection.Display(TRUE);
	cout << endl;
	
	// test on Container cctor
	cout << "Create a copy Container object.\n";
	Container collection2(collection);
	collection2.Display(TRUE);
	cout << endl;

	// more testing
	DoubleNumber *tempPtr1 = new DoubleNumber(1.91,  "I'm double #4");
	IntNumber *tempPtr2    = new IntNumber(45, "I'm integer #3");

	cout << "Create a Reference to object 'I'm integer #1'\n";
	IntNumber &tempRef = num1;
	tempRef.Display(TRUE);
	cout << endl;

	cout << "Create a Pointer of type class Number that points to an DoubleNumber object\n";
	Number *tempPtr3 = &num4; // okay
	tempPtr3->Display(TRUE);
	cout << endl;

	cout << "Delete two object pointers\n";
	delete tempPtr1;
	delete tempPtr2;

	// call the required global function
	Display_Object_Counters();

	
}

