/////////////////////////////////////////
//																     //
//  Definiton of the Number Base Class //
//																     //
//					Chungho Chau					     //
//																     //
/////////////////////////////////////////

#ifndef Number_CLASS  
#define Number_CLASS

#include <iostream.h>
#include <string.h>
#include "VString.h"
//#include "Generic.h"
     
class Number {
	
	friend class Container;
	friend void Display_Object_Counters(void);

  public:
				// ctor
				Number(const char *in_string) ;					

				// virtual dtor to avoid "donut" class
				virtual ~Number() {}

				// declare pure virtual function to assign base class 
				// as abstract class => only pointer or reference are used
				virtual void Display(BOOL needCRLF = FALSE) const=0 {}

				BOOL operator== (Number &other);
				

				static int count_total;
				static int count_current;
				
	protected:
				VString m_string;
				
	private:
				Number *m_nextPtr; // self-referential pointer for purpose of linklist
									
				// avoid use of cctor
				Number (const Number &other);

				// avoid use of =op
				Number &operator= (const Number &);

				// avoid use of ==op
				//BOOL operator== (Number &other);
};

#endif